START:
bits 16
org 0h

__MyKernelPlainEntry__ equ 0x100000


_jmp                equ 0  ;2  bytes
_nop                equ 2  ;1  byte
_OEMid              equ 3  ;8  bytes
_bytesPerSect       equ 11 ;2  bytes
_sectsPerClus       equ 13 ;1  byte
_resrvedSects       equ 14 ;2  bytes
_numOfFATs          equ 16 ;1  byte
_numRootDirEntries  equ 17 ;2  bytes
_numSectors         equ 19 ;2  bytes
_mediaType          equ 21 ;1  byte
_numFATsectors      equ 22 ;2  bytes
_sectorsPerTrack    equ 24 ;2  bytes
_numHeads           equ 26 ;2  bytes
_numHiddenSects     equ 28 ;4  bytes
_numSectorsHuge     equ 32 ;4  bytes
_driveNumber        equ 36 ;1  byte
_reserved           equ 37 ;1  byte
_signature          equ 38 ;1  byte
_volumeID           equ 39 ;4  bytes
_volumeLabel        equ 43 ;11 bytes
_FSType             equ 54 ;8  bytes







pushad
      cli
       call checkA20_unreal
       jnc .nomoreA20

          call enableA20_BIOS;;;;


      cli
       call checkA20_unreal
       jnc .nomoreA20
         call enableA20_KBC;;;;


       call checkA20_unreal
       jnc .nomoreA20
         call enableA20_Fast;;;;


       call checkA20_unreal
       jnc .nomoreA20
         int 19h   ;A20 error


      .nomoreA20:
      sti
popad





;;INIT: register/memory parameters configuration
;;INIT: register/memory parameters configuration
;;INIT: register/memory parameters configuration
  push word 0x7C0
  push word 0x7C0
  pop fs
  pop gs

  xor eax,eax
  push ax
  push ax
  pop ds
  pop ss

  mov sp,0x800
  push word 0x800
  pop es

  ;Here we are in (Un)Real Mode:
  ;Here we are in (Un)Real Mode:
  ;Here we are in (Un)Real Mode:
        mov     [fs:_jmp], dl         ;Save drive number we came from.
        mov     sp, 0x800              ;Configure stack end to 0x800

        xor     eax, eax                ;Segment. 32 bits cleared to 0
        mov     ds, ax                  ;DS (Data Segment) cleared to 0
        mov     ss, ax                  ;SS (Stack Segment) cleared to 0
        mov     es, sp                  ;Read directory at 800:0 {1C}. ES
                                        ;(Extra Segment) 0x800.
;;END:  register/memory parameters configuration
;;END:  register/memory parameters configuration
;;END:  register/memory parameters configuration





;;INIT: configure floppy information
;;INIT: configure floppy information
;;INIT: configure floppy information
  ;>   eax = 00000000
  xor eax,eax

  ;We keep in Unreal Mode from the previous INIT--END:
  ;We keep in Unreal Mode from the previous INIT--END:
  ;We keep in Unreal Mode from the previous INIT--END:
        mov     al, [fs:_numOfFATs]      ;Number of FATs
        mul     byte [fs:_numFATsectors] ;Times size of FAT |(in sectors?)
        add     ax, [fs:_resrvedSects]   ;Plus Sectors before first FAT
                 ;(_numOfFATs*_numFATsectors)+_resrvedSects
               ;eax = LBN of Root directory

        movzx   edi,word [fs:_numRootDirEntries] ;Root directory entries
   push   di         ; used again later
   dec   di         ;Convert to number of sectors

        shr     di, 4               ;16 directory entries per sector
   inc   di

        call    read_sectors    ;call forward
;;END:  configure floppy information
;;END:  configure floppy information
;;END:  configure floppy information



;;INIT: look for 8.3 name in the floppy root directory
;;INIT: look for 8.3 name in the floppy root directory
;;INIT: look for 8.3 name in the floppy root directory
  ;>  eax  = LBN of root directory
  ;>  edi  = length of root directory in sectors
  ;>  [sp] = length of root directory in entries
  ;>  esi  = 00000000

  ;We keep here in Unreal Mode from the 2 previous INIT--END blocks:
  ;We keep here in Unreal Mode from the 2 previous INIT--END blocks:
  ;We keep here in Unreal Mode from the 2 previous INIT--END blocks:
   lea   ebp, [eax+edi]      ;ebp = LBN of cluster 2

        pop     bx                      ;Root directory entries.

        xor     di, di               ;Point at directory {1C}
  .20:  mov     si, kernelFile       ;Name of file we want.

   xor   ecx, ecx
        mov     cl, 11       ;bytes in string "KERNEL  BIN"
push ds
push es
   push word 0x8000
   pop ds
        a32 rep cmpsb                   ;Found the file?.
                                        ;we use the 11 in CL
pop es
pop ds

   je   found         ;Yes
   add   cl, 21         ;Offset to next directory entry
   add   edi, ecx      ;Advance to next entry
   dec   bx         ;Loop through all entries
        jnz     .20


   ;Couldn't find file in directory
  boot_error:
  disk_error: 
   mov   ax, 0xE07      ;{3}
        int     10h          ;Ring the bell on error...
        jmp short $     ;end with infinite loop
;;END:  look for 8.3 name in the floppy root directory
;;END:  look for 8.3 name in the floppy root directory
;;END:  look for 8.3 name in the floppy root directory



;;INIT: read file according what the previous INIT--END found
;;INIT: read file according what the previous INIT--END found
;;INIT: read file according what the previous INIT--END found
  ;>> ecx   = 00000000
  ;> es     = 800
  ;> es:edi = Directory entry of file
  ;> ebp    = LBN of cluster 2
  ;> eax    = 0000????

  found:

          push    word [es:edi+0xF]        ;Starting cluster of file
          mov     di, [fs:_numFATsectors] ;Size of FAT (in sectors)
          mov     ax, [fs:_resrvedSects]  ;LBN of FAT
            call    read_sectors    ;call forward

   mov   bx, 0x4000
   mov   es, bx         ;es = 0x4000
   mov   edi, __MyKernelPlainEntry__-0x40000   ;{1D}{4B} One megabyte minus ES base
;;END:  read file according what the previous INIT--END found
;;END:  read file according what the previous INIT--END found
;;END:  read file according what the previous INIT--END found




;;INIT: final processes and control transfer to kernel entry point
;;INIT: final processes and control transfer to kernel entry point
;;INIT: final processes and control transfer to kernel entry point
  .10:

  ;>>    ecx = 0000????
  ;>    [sp] = Next cluster of file
  ;>     esi = 0000????
  ;>>    edx = 0000????
  ;>  es:edi = Destination address
  ;>     ebp = LBN of cluster 2
  ;>      ds = 0

   xor   eax, eax
   pop   si         ;Next cluster of file
   mov   bx, si
   cmp   si, 0xFF8      ;Valid cluster?
   jae   eof         ;No: assume end of file
               ;Yes: (c-bit set)
   rcr   bx, 1         ;bx = 0x8000 + cluster/2
   mov   bx, [bx+si]      ;Get word containing FAT entry
   jnc   .11         ;Entry is low 12 bits
   shr   bx, 4         ;Entry was high 12 bits
  .11:  and     bh, 0xF                 ;Mask to just 12 bits
   push   bx         ;Save cluster after next
   push   di         ;Save destination address {7}
        mov     al, [fS:_sectsPerClus]     ;Size of each cluster
   mov   di, ax         ;  (in sectors)
   dec   si
   dec   si
   mul   esi         ;Times cluster number minus 2
   add   eax, ebp      ;Plus LBN of cluster 2   

   call   read_sectors      ;Read that cluster

  ;>     ecx = 0000????
  ;>>    edx = 0000????
  ;>      di = Clustersize in sectors
  ;>     esi = 0
  ;>>    ebp = LBN of cluster 2
  ;>    [sp] = Bottom 16-bits of destination address {7}
  ;>> [sp+2] = Following cluster
  ;>      ds = 0
  ;>      es = 4000

   mov   cx, di         ;Cluster size in sectors
   xchg   ch, cl         ;Cluster size in words
   pop   di         ;Restore destination address {7}

   es a32 rep movsw


   jmp short .10         ;Loop until end of file

  ;>     eax = 0
  ;>     edx = 0000????
  ;>      bx = 0FF?

  eof:
.20:
   int   8         ;{8}
   loop   .20



 ;At this point, we have already copied our KERNEL.BIN
 ;into 0x100000, and now we can either jump to it or,
 ;preferably, do some other tasks and helping ourselves
 ;by using the BIOS to get all important information
 ;possible before having it unusable because of
 ;Protected Mode.
 ;;


 pushad
 ;;;;;INIT: Add here any other initialization code
 ;;;;;INIT: Add here any other initialization code
 ;;;;;INIT: Add here any other initialization code
 ;;;;;INIT: Add here any other initialization code
 ;;;;;INIT: Add here any other initialization code
 ;;;;;INIT: Add here any other initialization code
 ;;;;;INIT: Add here any other initialization code
 ;;;;;INIT: Add here any other initialization code
 ;;;;;INIT: Add here any other initialization code
 ;;;;;INIT: Add here any other initialization code
 ;;;;;INIT: Add here any other initialization code
 ;;;;;INIT: Add here any other initialization code
 ;;;;;INIT: Add here any other initialization code
 ;;;;;INIT: Add here any other initialization code
 ;;;;;INIT: Add here any other initialization code
 ;;;;;INIT: Add here any other initialization code


 ;;;;;END:  Add here any other initialization code
 ;;;;;END:  Add here any other initialization code
 ;;;;;END:  Add here any other initialization code
 ;;;;;END:  Add here any other initialization code
 ;;;;;END:  Add here any other initialization code
 ;;;;;END:  Add here any other initialization code
 ;;;;;END:  Add here any other initialization code
 ;;;;;END:  Add here any other initialization code
 ;;;;;END:  Add here any other initialization code
 ;;;;;END:  Add here any other initialization code
 ;;;;;END:  Add here any other initialization code
 ;;;;;END:  Add here any other initialization code
 ;;;;;END:  Add here any other initialization code
 ;;;;;END:  Add here any other initialization code
 ;;;;;END:  Add here any other initialization code
 ;;;;;END:  Add here any other initialization code
 popad










  ;Now reactivate Protected Mode, minimally load
  ;some data segments and jump to the kernel:
  ;;


   cli            ;{6}


   mov   eax, CR0      ;Turn on protected mode
   or   eax, 0x00000001
   mov   CR0, eax
        mov     cl, Data32              ;Setup ds and es
   push   cx         ;{5}
   pop   ds
   mov   es, cx
   mov   fs, cx
   mov   gs, cx
     a32   jmp dword Code32:__MyKernelPlainEntry__   ;Go


;;END:  final processes and control transfer to kernel entry point
;;END:  final processes and control transfer to kernel entry point
;;END:  final processes and control transfer to kernel entry point



;;INIT: read_sectors
;;INIT: read_sectors
;;INIT: read_sectors
  read_sectors:
  ; Input:
  ;       EAX = LBN
  ;       DI  = sector count
  ;       ES = segment
  ; Output:
  ;       EBX high half cleared
  ;       DL = drive #
  ;       EDX high half cleared
  ;       ESI = 0
  ; Clobbered:
  ;       BX, CX, DH

          push    eax
          push    di
          push    es

  .10:    push    eax             ;LBN

          cdq                     ;edx = 0
          movzx   ebx, byte [fs:_sectorsPerTrack]
          div     ebx             ;EAX=track ;EDX=sector-1
          mov     cx, dx          ;CL=sector-1 ;CH=0
          sub     bl, dl          ;BX = max transfer before end of track
          cmp     di, bx          ;Do we want more than that?
          ja      .20             ;Yes, do just this much now
          mov     bx, di          ;No, do it all now
  .20:    mov     esi, ebx        ;Save count for this transfer.

          inc     cx              ;CL=Sector number
          xor     dx, dx
          mov     bl, [fs:_numHeads]
          div     ebx             ;EAX=cylinder ;EDX=head

          mov     dh, dl          ;Head
          mov     dl, [fs:_jmp]  ;Drive number
          xchg    ch, al          ;CH=Low 8 bits of cylinder number; AL=0
          shr     ax, 2           ;AL[6:7]=High two bits of cylinder
          or      cl, al          ;CX = Cylinder and sector

          mov     ax, si          ;Sector count
          mov     ah, 2           ;Read
          xor     bx, bx
          push    ax
          int     13h
          pop     ax
          jnc     .30

          int     13h             ;If at second you don't succeed, give up
          jc near disk_error

  .30:    pop     eax
          add     eax, esi        ;Advance LBN

          push    si
          shl     si, 5
          mov     bx, es
          add     bx, si          ;Advance segment
          mov     es, bx
          pop     si

          sub     di, si
          ja      .10

          pop     es
          pop     di
          pop     eax
          xor     si, si
          ret 
;;END:  read_sectors
;;END:  read_sectors
;;END:  read_sectors


kernelFile db 'KERNEL  BIN'


;INIT: GDT
;INIT: GDT
;INIT: GDT
   GDT:
   _SELNull equ 0   ;WARNING: this sector, besides being the GDT pointer,
      GDT_size:     ;         is the NULL selector.
        dw GDTsize
      GDT_actualptr:
        dd GDT
       dw 0x0000

   Code32 equ 8
     dw 0FFFFh       ; bits 0-15 length
     dw 00000h       ; bits 0-15 base addr
     db 0            ; bits 16-23 base addr
     db 10011010b    ; bits P,DPL,DT & type
     db 11001111b    ; bits G,D & bits 16-19 length
     db 0            ; bits 24-31 base addr

   Data32 equ 16
     dw 0FFFFh       ; bits 0-15 length
     dw 00000h       ; bits 0-15 base addr
     db 0            ; bits 16-23 base addr
     db 10010010b    ; bits P,DPL,DT & type
     db 11001111b    ; bits G,D & bits 16-19 length
     db 0            ; bits 24-31 base addr
   GDT_end:

   GDTsize equ (GDT_end-GDT)-1
;END:  GDT
;END:  GDT
;END:  GDT







;;;INIT: A20 enabling functions
;;;INIT: A20 enabling functions
;;;INIT: A20 enabling functions


  ;This function waits until the
  ;Keybard Controller is ready to
  ;accept commands.
  ;;
  ;;;
    KeybCtrl_waitUntilCommandable:
    push ax


    .waitUntilReady:
     in al,0x64    ;Port 0x64 is the Status
                   ;Register of the keyboard
                   ;controller port located
                   ;on the motherboard.


     test al,00000010b ;We see if bit 1 of the returned
                       ;byte at 0x64 is set to 1, which
                       ;means that the controller is NOT
                       ;ready to accept commands. It means
                       ;"Input Buffer Full (port 0x60 or 0x64);
                       ;don't write yet".



     jnz .waitUntilReady  ;Repeat until bit 1 of byte from
                          ;port 0x64 is cleared to 0 or, in
                          ;other words, until the keyboard
                          ;controller is ready to accept
                          ;commands. It would mean "Input
                          ;Buffer Empty (port 0x60 or 0x64); can
                          ;be written".

       ;Note that writing the Input Buffer through
       ;port 0x64 causes the byte to be interpreted
       ;as a command.
       ;
       ;And if we write the Input Buffer through
       ;port 0x60 causes the byte to be interpreted
       ;as data, usually as a parameter to an immediate
       ;previously sent command at port 0x64.

    pop ax
      ret

















  enableA20_KBC:
  ;;;Wait for controller to accept
  ;;;commands
  ;;
  ;
   call KeybCtrl_waitUntilCommandable


  ;;;Write Output Port (Command -- Step 1/2):
  ;;;Write Output Port (Command -- Step 1/2):
  ;;;Write Output Port (Command -- Step 1/2):
    mov al,0xD1    ;This command is to write the
                   ;status byte. This command is
                   ;called WRITE OUTPUT PORT.

    out 0x64,al    ;Here we send the command, and
                   ;it gets processed.


  ;;;Wait for controller to accept
  ;;;commands
  ;;
  ;
   call KeybCtrl_waitUntilCommandable


  ;;;Write The Output Port (Command Parameter -- Step 2/2):
  ;;;Write The Output Port (Command Parameter -- Step 2/2):
  ;;;Write The Output Port (Command Parameter -- Step 2/2):
    mov al,11111111b ;This is a data byte to serve
                     ;as a parameter to the previous
                     ;controller command (0xD1). We
                     ;are setting the necessary bits
                     ;here to the normal operation
                     ;of the controller, and, of course,
                     ;it is here that we enable the A20
                     ;Address Line by setting its bit
                     ;to 1.
    ;bit 0-Normal           (1) or Reset CPU (0)
    ;bit 1-Enable A20       (1) or Disable A20 (0)
    ;bit 2-Data to Mouse    (1) or Disabled (0)
    ;bit 3-Mouse Clock      (1) or Disabled (0)
    ;bit 4-IRQ1 Active      (1) or IRQ1 Inactive (0)
    ;bit 5-IRQ12 Active     (1) or IRQ12 Inactive (0)
    ;bit 6-Keyboard Clock   (1) or Disabled (0)
    ;bit 7-Data to Keyboard (1) or Disabled (0)


    out 0x60,al    ;We send this bit-set to the
                   ;data port of the keyboard. At
                   ;this point is where really the
                   ;A20 line gets enabled.


  ret





  enableA20_BIOS:
   sti
   mov ax,2401h
   int 15h


  ret




  enableA20_Fast:
    in al,0x92
    test al,00000010b
    jnz .no92
      or  al,00000010b
      and al,0xFE
      out 0x92, al

    .no92:

  ret








  checkA20_unreal:
    pushad

    ;Test if we can reach very much memory in 16-bit mode
    ;and also test for A20 enabled by using an odd megabyte



    ;;Clear any past test results
    ;;;
      mov esi,1048576*1
      push dword[esi]     ;safeguard contents
      mov dword[esi],0    ;Our intended address

  ;    mov esi,1048576*0
      push dword[si]
      mov dword[si],0    ;An A20-disabled wrapped address



  ;  mov esi,1048576*1
    mov dword[esi],"1@2@" ;Place here a colorful "12"
    mov ebx,[esi]         ;Store for later comparison
;    pop dword[esi]        ;restore original


  ;  mov esi,1048576*0     ;See the pontetially wrapped up address
    mov ecx,[si]         ;Store for the comparison
    pop dword[si]        ;restore original
    pop dword[esi]        ;restore original





    cmp ebx,ecx           ;Compare to see
    jne .noA20error       ;If they are different, A20 is enabled an all is OK
     stc  ;gate error
    jmp .ended


    .noA20error:
     clc  ;all OK


   .ended:

   popad
  ret



;;;END:  A20 enabling functions
;;;END:  A20 enabling functions
;;;END:  A20 enabling functions
